-- -------------------------------------------------------------
-- 
-- File Name: E:\Liquid Instruments Dropbox\Fengyuan Deng\Projects\_Collaborative_Projects\2021-0908-HDLCoderTutorial\_Code\_MATLAB_NEWPORTNAME\codegen\DSP\hdlsrc\DSP_fixpt.vhd
-- Created: 2021-09-29 19:18:37
-- 
-- Generated by MATLAB 9.10, MATLAB Coder 5.2 and HDL Coder 3.18
-- 
-- 
-- 
-- -------------------------------------------------------------
-- Rate and Clocking Details
-- -------------------------------------------------------------
-- Design base rate: 1
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: DSP_fixpt
-- Source Path: DSP_fixpt
-- Hierarchy Level: 0
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY DSP_fixpt IS
  PORT( Clk                               :   IN    std_logic;
        Reset                             :   IN    std_logic;
        InputA                            :   IN    signed(15 DOWNTO 0);  -- sfix16
        OutputA                           :   OUT   signed(15 DOWNTO 0)  -- sfix16
        );
END DSP_fixpt;


ARCHITECTURE rtl OF DSP_fixpt IS

  -- Signals
  SIGNAL tmp                              : std_logic;
  SIGNAL tmp_1                            : std_logic;
  SIGNAL out0                             : unsigned(14 DOWNTO 0);  -- ufix15
  SIGNAL out0_1                           : unsigned(14 DOWNTO 0);  -- ufix15
  SIGNAL tmp_2                            : unsigned(14 DOWNTO 0);  -- ufix15
  SIGNAL out0_2                           : unsigned(14 DOWNTO 0);  -- ufix15
  SIGNAL tmp_3                            : unsigned(14 DOWNTO 0);  -- ufix15

BEGIN
  -- HDL code generation from MATLAB function: DSP_fixpt
  
  tmp <= '1' WHEN InputA < to_signed(-16#0CCC#, 16) ELSE
      '0';

  -- Logic to perform the Schmitt trigger function.
  -- 
  -- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  -- 
  --                                                                          %
  -- 
  --          Generated by MATLAB 9.10 and Fixed-Point Designer 7.2           %
  -- 
  --                                                                          %
  -- 
  -- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  -- 
  -- Retains variable value between function calls.
  -- 
  -- Set the upper threshold to 1/10 of the full positive range.
  -- 
  -- Set the lower threshold to 1/10 of the full negative range.
  
  tmp_1 <= '1' WHEN InputA > to_signed(16#0CCC#, 16) ELSE
      '0';

  -- HDL code generation from MATLAB function: DSP_fixpt_trueregionp5
  out0 <= to_unsigned(16#0000#, 15);

  -- HDL code generation from MATLAB function: DSP_fixpt_trueregionp1
  out0_1 <= to_unsigned(16#7FFF#, 15);

  -- Assign variable out0 to the output.
  out0_reg_process : PROCESS (Clk)
  BEGIN
    IF Clk'EVENT AND Clk = '1' THEN
      IF Reset = '1' THEN
        out0_2 <= to_unsigned(16#0000#, 15);
      ELSE 
        out0_2 <= tmp_2;
      END IF;
    END IF;
  END PROCESS out0_reg_process;


  -- HDL code generation from MATLAB function: DSP_fixpt_falseregionp1
  
  tmp_3 <= out0_2 WHEN tmp = '0' ELSE
      out0;

  
  tmp_2 <= tmp_3 WHEN tmp_1 = '0' ELSE
      out0_1;

  OutputA <= signed(resize(tmp_2, 16));

END rtl;

